<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooKeeperMain.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">ZooKeeperMain.java</span></div><h1>ZooKeeperMain.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.NoSuchElementException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.AsyncCallback.DataCallback;
import org.apache.zookeeper.ZooDefs.Ids;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.data.Stat;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * The command line client to ZooKeeper.
 *
 */
public class ZooKeeperMain {
<span class="fc" id="L52">    private static final Logger LOG = LoggerFactory.getLogger(ZooKeeperMain.class);</span>
<span class="fc" id="L53">    protected static final Map&lt;String,String&gt; commandMap = new HashMap&lt;String,String&gt;( );</span>

<span class="pc" id="L55">    protected MyCommandOptions cl = new MyCommandOptions();</span>
<span class="pc" id="L56">    protected HashMap&lt;Integer,String&gt; history = new HashMap&lt;Integer,String&gt;( );</span>
<span class="pc" id="L57">    protected int commandCount = 0;</span>
<span class="pc" id="L58">    protected boolean printWatches = true;</span>

    protected ZooKeeper zk;
<span class="pc" id="L61">    protected String host = &quot;&quot;;</span>

    public boolean getPrintWatches( ) {
<span class="nc" id="L64">        return printWatches;</span>
    }

    static {
<span class="fc" id="L68">        commandMap.put(&quot;connect&quot;, &quot;host:port&quot;);</span>
<span class="fc" id="L69">        commandMap.put(&quot;close&quot;,&quot;&quot;);</span>
<span class="fc" id="L70">        commandMap.put(&quot;create&quot;, &quot;[-s] [-e] path data acl&quot;);</span>
<span class="fc" id="L71">        commandMap.put(&quot;delete&quot;,&quot;path [version]&quot;);</span>
<span class="fc" id="L72">        commandMap.put(&quot;rmr&quot;,&quot;path&quot;);</span>
<span class="fc" id="L73">        commandMap.put(&quot;set&quot;,&quot;path data [version]&quot;);</span>
<span class="fc" id="L74">        commandMap.put(&quot;get&quot;,&quot;path [watch]&quot;);</span>
<span class="fc" id="L75">        commandMap.put(&quot;ls&quot;,&quot;path [watch]&quot;);</span>
<span class="fc" id="L76">        commandMap.put(&quot;ls2&quot;,&quot;path [watch]&quot;);</span>
<span class="fc" id="L77">        commandMap.put(&quot;getAcl&quot;,&quot;path&quot;);</span>
<span class="fc" id="L78">        commandMap.put(&quot;setAcl&quot;,&quot;path acl&quot;);</span>
<span class="fc" id="L79">        commandMap.put(&quot;stat&quot;,&quot;path [watch]&quot;);</span>
<span class="fc" id="L80">        commandMap.put(&quot;sync&quot;,&quot;path&quot;);</span>
<span class="fc" id="L81">        commandMap.put(&quot;setquota&quot;,&quot;-n|-b val path&quot;);</span>
<span class="fc" id="L82">        commandMap.put(&quot;listquota&quot;,&quot;path&quot;);</span>
<span class="fc" id="L83">        commandMap.put(&quot;delquota&quot;,&quot;[-n|-b] path&quot;);</span>
<span class="fc" id="L84">        commandMap.put(&quot;history&quot;,&quot;&quot;);</span>
<span class="fc" id="L85">        commandMap.put(&quot;redo&quot;,&quot;cmdno&quot;);</span>
<span class="fc" id="L86">        commandMap.put(&quot;printwatches&quot;, &quot;on|off&quot;);</span>
<span class="fc" id="L87">        commandMap.put(&quot;quit&quot;,&quot;&quot;);</span>
<span class="fc" id="L88">        commandMap.put(&quot;addauth&quot;, &quot;scheme auth&quot;);</span>
    }

    static void usage() {
<span class="nc" id="L92">        System.err.println(&quot;ZooKeeper -server host:port cmd args&quot;);</span>
<span class="nc bnc" id="L93" title="All 2 branches missed.">        for (String cmd : commandMap.keySet()) {</span>
<span class="nc" id="L94">            System.err.println(&quot;\t&quot;+cmd+ &quot; &quot; + commandMap.get(cmd));</span>
<span class="nc" id="L95">        }</span>
<span class="nc" id="L96">    }</span>

<span class="nc" id="L98">    private class MyWatcher implements Watcher {</span>
        public void process(WatchedEvent event) {
<span class="nc bnc" id="L100" title="All 2 branches missed.">            if (getPrintWatches()) {</span>
<span class="nc" id="L101">                ZooKeeperMain.printMessage(&quot;WATCHER::&quot;);</span>
<span class="nc" id="L102">                ZooKeeperMain.printMessage(event.toString());</span>
            }
<span class="nc" id="L104">        }</span>
    }

    static private int getPermFromString(String permString) {
<span class="fc" id="L108">        int perm = 0;</span>
<span class="fc bfc" id="L109" title="All 2 branches covered.">        for (int i = 0; i &lt; permString.length(); i++) {</span>
<span class="pc bpc" id="L110" title="4 of 6 branches missed.">            switch (permString.charAt(i)) {</span>
            case 'r':
<span class="nc" id="L112">                perm |= ZooDefs.Perms.READ;</span>
<span class="nc" id="L113">                break;</span>
            case 'w':
<span class="nc" id="L115">                perm |= ZooDefs.Perms.WRITE;</span>
<span class="nc" id="L116">                break;</span>
            case 'c':
<span class="nc" id="L118">                perm |= ZooDefs.Perms.CREATE;</span>
<span class="nc" id="L119">                break;</span>
            case 'd':
<span class="fc" id="L121">                perm |= ZooDefs.Perms.DELETE;</span>
<span class="fc" id="L122">                break;</span>
            case 'a':
<span class="nc" id="L124">                perm |= ZooDefs.Perms.ADMIN;</span>
<span class="nc" id="L125">                break;</span>
            default:
<span class="fc" id="L127">                System.err</span>
<span class="fc" id="L128">                .println(&quot;Unknown perm type: &quot; + permString.charAt(i));</span>
            }
        }
<span class="fc" id="L131">        return perm;</span>
    }

    private static void printStat(Stat stat) {
<span class="nc" id="L135">        System.err.println(&quot;cZxid = 0x&quot; + Long.toHexString(stat.getCzxid()));</span>
<span class="nc" id="L136">        System.err.println(&quot;ctime = &quot; + new Date(stat.getCtime()).toString());</span>
<span class="nc" id="L137">        System.err.println(&quot;mZxid = 0x&quot; + Long.toHexString(stat.getMzxid()));</span>
<span class="nc" id="L138">        System.err.println(&quot;mtime = &quot; + new Date(stat.getMtime()).toString());</span>
<span class="nc" id="L139">        System.err.println(&quot;pZxid = 0x&quot; + Long.toHexString(stat.getPzxid()));</span>
<span class="nc" id="L140">        System.err.println(&quot;cversion = &quot; + stat.getCversion());</span>
<span class="nc" id="L141">        System.err.println(&quot;dataVersion = &quot; + stat.getVersion());</span>
<span class="nc" id="L142">        System.err.println(&quot;aclVersion = &quot; + stat.getAversion());</span>
<span class="nc" id="L143">        System.err.println(&quot;ephemeralOwner = 0x&quot;</span>
<span class="nc" id="L144">        		+ Long.toHexString(stat.getEphemeralOwner()));</span>
<span class="nc" id="L145">        System.err.println(&quot;dataLength = &quot; + stat.getDataLength());</span>
<span class="nc" id="L146">        System.err.println(&quot;numChildren = &quot; + stat.getNumChildren());</span>
<span class="nc" id="L147">    }</span>

    /**
     * A storage class for both command line options and shell commands.
     *
     */
    static class MyCommandOptions {

<span class="fc" id="L155">        private Map&lt;String,String&gt; options = new HashMap&lt;String,String&gt;();</span>
<span class="fc" id="L156">        private List&lt;String&gt; cmdArgs = null;</span>
<span class="fc" id="L157">        private String command = null;</span>
<span class="fc" id="L158">        public static final Pattern ARGS_PATTERN = Pattern.compile(&quot;\\s*([^\&quot;\']\\S*|\&quot;[^\&quot;]*\&quot;|'[^']*')\\s*&quot;);</span>
<span class="fc" id="L159">        public static final Pattern QUOTED_PATTERN = Pattern.compile(&quot;^([\'\&quot;])(.*)(\\1)$&quot;);</span>

<span class="fc" id="L161">        public MyCommandOptions() {</span>
<span class="fc" id="L162">          options.put(&quot;server&quot;, &quot;localhost:2181&quot;);</span>
<span class="fc" id="L163">          options.put(&quot;timeout&quot;, &quot;30000&quot;);</span>
<span class="fc" id="L164">        }</span>

        public String getOption(String opt) {
<span class="nc" id="L167">            return options.get(opt);</span>
        }

        public String getCommand( ) {
<span class="fc" id="L171">            return command;</span>
        }

        public String getCmdArgument( int index ) {
<span class="fc" id="L175">            return cmdArgs.get(index);</span>
        }

        public int getNumArguments( ) {
<span class="fc" id="L179">            return cmdArgs.size();</span>
        }

        public String[] getArgArray() {
<span class="fc" id="L183">            return cmdArgs.toArray(new String[0]);</span>
        }

        /**
         * Parses a command line that may contain one or more flags
         * before an optional command string
         * @param args command line arguments
         * @return true if parsing succeeded, false otherwise.
         */
        public boolean parseOptions(String[] args) {
<span class="nc" id="L193">            List&lt;String&gt; argList = Arrays.asList(args);</span>
<span class="nc" id="L194">            Iterator&lt;String&gt; it = argList.iterator();</span>

<span class="nc bnc" id="L196" title="All 2 branches missed.">            while (it.hasNext()) {</span>
<span class="nc" id="L197">                String opt = it.next();</span>
                try {
<span class="nc bnc" id="L199" title="All 2 branches missed.">                    if (opt.equals(&quot;-server&quot;)) {</span>
<span class="nc" id="L200">                        options.put(&quot;server&quot;, it.next());</span>
<span class="nc bnc" id="L201" title="All 2 branches missed.">                    } else if (opt.equals(&quot;-timeout&quot;)) {</span>
<span class="nc" id="L202">                        options.put(&quot;timeout&quot;, it.next());</span>
<span class="nc bnc" id="L203" title="All 2 branches missed.">                    } else if (opt.equals(&quot;-r&quot;)) {</span>
<span class="nc" id="L204">                        options.put(&quot;readonly&quot;, &quot;true&quot;);</span>
                    }
<span class="nc" id="L206">                } catch (NoSuchElementException e){</span>
<span class="nc" id="L207">                    System.err.println(&quot;Error: no argument found for option &quot;</span>
                            + opt);
<span class="nc" id="L209">                    return false;</span>
<span class="nc" id="L210">                }</span>

<span class="nc bnc" id="L212" title="All 2 branches missed.">                if (!opt.startsWith(&quot;-&quot;)) {</span>
<span class="nc" id="L213">                    command = opt;</span>
<span class="nc" id="L214">                    cmdArgs = new ArrayList&lt;String&gt;( );</span>
<span class="nc" id="L215">                    cmdArgs.add( command );</span>
<span class="nc bnc" id="L216" title="All 2 branches missed.">                    while (it.hasNext()) {</span>
<span class="nc" id="L217">                        cmdArgs.add(it.next());</span>
                    }
<span class="nc" id="L219">                    return true;</span>
                }
<span class="nc" id="L221">            }</span>
<span class="nc" id="L222">            return true;</span>
        }

        /**
         * Breaks a string into command + arguments.
         * @param cmdstring string of form &quot;cmd arg1 arg2..etc&quot;
         * @return true if parsing succeeded.
         */
        public boolean parseCommand( String cmdstring ) {
<span class="fc" id="L231">            Matcher matcher = ARGS_PATTERN.matcher(cmdstring);</span>

<span class="fc" id="L233">            List&lt;String&gt; args = new LinkedList&lt;String&gt;();</span>
<span class="fc bfc" id="L234" title="All 2 branches covered.">            while (matcher.find()) {</span>
<span class="fc" id="L235">                String value = matcher.group(1);</span>
<span class="fc bfc" id="L236" title="All 2 branches covered.">                if (QUOTED_PATTERN.matcher(value).matches()) {</span>
                    // Strip off the surrounding quotes
<span class="fc" id="L238">                    value = value.substring(1, value.length() - 1);</span>
                }
<span class="fc" id="L240">                args.add(value);</span>
<span class="fc" id="L241">            }</span>
<span class="pc bpc" id="L242" title="1 of 2 branches missed.">            if (args.isEmpty()){</span>
<span class="nc" id="L243">                return false;</span>
            }
<span class="fc" id="L245">            command = args.get(0);</span>
<span class="fc" id="L246">            cmdArgs = args;</span>
<span class="fc" id="L247">            return true;</span>
        }
    }


    /**
     * Makes a list of possible completions, either for commands
     * or for zk nodes if the token to complete begins with /
     *
     */


    protected void addToHistory(int i,String cmd) {
<span class="fc" id="L260">        history.put(i, cmd);</span>
<span class="fc" id="L261">    }</span>

    public static List&lt;String&gt; getCommands() {
<span class="nc" id="L264">        return new LinkedList&lt;String&gt;(commandMap.keySet());</span>
    }

    protected String getPrompt() {       
<span class="nc" id="L268">        return &quot;[zk: &quot; + host + &quot;(&quot;+zk.getState()+&quot;)&quot; + &quot; &quot; + commandCount + &quot;] &quot;;</span>
    }

    public static void printMessage(String msg) {
<span class="nc" id="L272">        System.out.println(&quot;\n&quot;+msg);</span>
<span class="nc" id="L273">    }</span>

    protected void connectToZK(String newHost) throws InterruptedException, IOException {
<span class="nc bnc" id="L276" title="All 4 branches missed.">        if (zk != null &amp;&amp; zk.getState().isAlive()) {</span>
<span class="nc" id="L277">            zk.close();</span>
        }
<span class="nc" id="L279">        host = newHost;</span>
<span class="nc bnc" id="L280" title="All 2 branches missed.">        boolean readOnly = cl.getOption(&quot;readonly&quot;) != null;</span>
<span class="nc" id="L281">        zk = new ZooKeeper(host,</span>
<span class="nc" id="L282">                 Integer.parseInt(cl.getOption(&quot;timeout&quot;)),</span>
                 new MyWatcher(), readOnly);
<span class="nc" id="L284">    }</span>
    
    public static void main(String args[])
        throws KeeperException, IOException, InterruptedException
    {
<span class="nc" id="L289">        ZooKeeperMain main = new ZooKeeperMain(args);</span>
<span class="nc" id="L290">        main.run();</span>
<span class="nc" id="L291">    }</span>

<span class="nc" id="L293">    public ZooKeeperMain(String args[]) throws IOException, InterruptedException {</span>
<span class="nc" id="L294">        cl.parseOptions(args);</span>
<span class="nc" id="L295">        System.out.println(&quot;Connecting to &quot; + cl.getOption(&quot;server&quot;));</span>
<span class="nc" id="L296">        connectToZK(cl.getOption(&quot;server&quot;));</span>
        //zk = new ZooKeeper(cl.getOption(&quot;server&quot;),
//                Integer.parseInt(cl.getOption(&quot;timeout&quot;)), new MyWatcher());
<span class="nc" id="L299">    }</span>

<span class="fc" id="L301">    public ZooKeeperMain(ZooKeeper zk) {</span>
<span class="fc" id="L302">      this.zk = zk;</span>
<span class="fc" id="L303">    }</span>

    @SuppressWarnings(&quot;unchecked&quot;)
    void run() throws KeeperException, IOException, InterruptedException {
<span class="nc bnc" id="L307" title="All 2 branches missed.">        if (cl.getCommand() == null) {</span>
<span class="nc" id="L308">            System.out.println(&quot;Welcome to ZooKeeper!&quot;);</span>

<span class="nc" id="L310">            boolean jlinemissing = false;</span>
            // only use jline if it's in the classpath
            try {
<span class="nc" id="L313">                Class consoleC = Class.forName(&quot;jline.ConsoleReader&quot;);</span>
<span class="nc" id="L314">                Class completorC =</span>
<span class="nc" id="L315">                    Class.forName(&quot;org.apache.zookeeper.JLineZNodeCompletor&quot;);</span>

<span class="nc" id="L317">                System.out.println(&quot;JLine support is enabled&quot;);</span>

<span class="nc" id="L319">                Object console =</span>
<span class="nc" id="L320">                    consoleC.getConstructor().newInstance();</span>

<span class="nc" id="L322">                Object completor =</span>
<span class="nc" id="L323">                    completorC.getConstructor(ZooKeeper.class).newInstance(zk);</span>
<span class="nc" id="L324">                Method addCompletor = consoleC.getMethod(&quot;addCompletor&quot;,</span>
<span class="nc" id="L325">                        Class.forName(&quot;jline.Completor&quot;));</span>
<span class="nc" id="L326">                addCompletor.invoke(console, completor);</span>

                String line;
<span class="nc" id="L329">                Method readLine = consoleC.getMethod(&quot;readLine&quot;, String.class);</span>
<span class="nc bnc" id="L330" title="All 2 branches missed.">                while ((line = (String)readLine.invoke(console, getPrompt())) != null) {</span>
<span class="nc" id="L331">                    executeLine(line);</span>
                }
<span class="nc" id="L333">            } catch (ClassNotFoundException e) {</span>
<span class="nc" id="L334">                LOG.debug(&quot;Unable to start jline&quot;, e);</span>
<span class="nc" id="L335">                jlinemissing = true;</span>
<span class="nc" id="L336">            } catch (NoSuchMethodException e) {</span>
<span class="nc" id="L337">                LOG.debug(&quot;Unable to start jline&quot;, e);</span>
<span class="nc" id="L338">                jlinemissing = true;</span>
<span class="nc" id="L339">            } catch (InvocationTargetException e) {</span>
<span class="nc" id="L340">                LOG.debug(&quot;Unable to start jline&quot;, e);</span>
<span class="nc" id="L341">                jlinemissing = true;</span>
<span class="nc" id="L342">            } catch (IllegalAccessException e) {</span>
<span class="nc" id="L343">                LOG.debug(&quot;Unable to start jline&quot;, e);</span>
<span class="nc" id="L344">                jlinemissing = true;</span>
<span class="nc" id="L345">            } catch (InstantiationException e) {</span>
<span class="nc" id="L346">                LOG.debug(&quot;Unable to start jline&quot;, e);</span>
<span class="nc" id="L347">                jlinemissing = true;</span>
<span class="nc" id="L348">            }</span>

<span class="nc bnc" id="L350" title="All 2 branches missed.">            if (jlinemissing) {</span>
<span class="nc" id="L351">                System.out.println(&quot;JLine support is disabled&quot;);</span>
<span class="nc" id="L352">                BufferedReader br =</span>
                    new BufferedReader(new InputStreamReader(System.in));

                String line;
<span class="nc bnc" id="L356" title="All 2 branches missed.">                while ((line = br.readLine()) != null) {</span>
<span class="nc" id="L357">                    executeLine(line);</span>
                }
            }
<span class="nc" id="L360">        } else {</span>
            // Command line args non-null.  Run what was passed.
<span class="nc" id="L362">            processCmd(cl);</span>
        }
<span class="nc" id="L364">    }</span>

    public void executeLine(String line)
    throws InterruptedException, IOException, KeeperException {
<span class="pc bpc" id="L368" title="1 of 2 branches missed.">      if (!line.equals(&quot;&quot;)) {</span>
<span class="fc" id="L369">        cl.parseCommand(line);</span>
<span class="fc" id="L370">        addToHistory(commandCount,line);</span>
<span class="fc" id="L371">        processCmd(cl);</span>
<span class="fc" id="L372">        commandCount++;</span>
      }
<span class="fc" id="L374">    }</span>

<span class="fc" id="L376">    private static DataCallback dataCallback = new DataCallback() {</span>

        public void processResult(int rc, String path, Object ctx, byte[] data,
                Stat stat) {
<span class="nc bnc" id="L380" title="All 2 branches missed.">            System.out.println(&quot;rc = &quot; + rc + &quot; path = &quot; + path + &quot; data = &quot;</span>
                    + (data == null ? &quot;null&quot; : new String(data)) + &quot; stat = &quot;);
<span class="nc" id="L382">            printStat(stat);</span>
<span class="nc" id="L383">        }</span>

    };

    /**
     * trim the quota tree to recover unwanted tree elements
     * in the quota's tree
     * @param zk the zookeeper client
     * @param path the path to start from and go up and see if their
     * is any unwanted parent in the path.
     * @return true if sucessful
     * @throws KeeperException
     * @throws IOException
     * @throws InterruptedException
     */
    private static boolean trimProcQuotas(ZooKeeper zk, String path)
        throws KeeperException, IOException, InterruptedException
    {
<span class="nc bnc" id="L401" title="All 2 branches missed.">        if (Quotas.quotaZookeeper.equals(path)) {</span>
<span class="nc" id="L402">            return true;</span>
        }
<span class="nc" id="L404">        List&lt;String&gt; children = zk.getChildren(path, false);</span>
<span class="nc bnc" id="L405" title="All 2 branches missed.">        if (children.size() == 0) {</span>
<span class="nc" id="L406">            zk.delete(path, -1);</span>
<span class="nc" id="L407">            String parent = path.substring(0, path.lastIndexOf('/'));</span>
<span class="nc" id="L408">            return trimProcQuotas(zk, parent);</span>
        } else {
<span class="nc" id="L410">            return true;</span>
        }
    }

    /**
     * this method deletes quota for a node.
     * @param zk the zookeeper client
     * @param path the path to delete quota for
     * @param bytes true if number of bytes needs to
     * be unset
     * @param numNodes true if number of nodes needs
     * to be unset
     * @return true if quota deletion is successful
     * @throws KeeperException
     * @throws IOException
     * @throws InterruptedException
     */
    public static boolean delQuota(ZooKeeper zk, String path,
            boolean bytes, boolean numNodes)
        throws KeeperException, IOException, InterruptedException
    {
<span class="nc" id="L431">        String parentPath = Quotas.quotaZookeeper + path;</span>
<span class="nc" id="L432">        String quotaPath = Quotas.quotaZookeeper + path + &quot;/&quot; + Quotas.limitNode;</span>
<span class="nc bnc" id="L433" title="All 2 branches missed.">        if (zk.exists(quotaPath, false) == null) {</span>
<span class="nc" id="L434">            System.out.println(&quot;Quota does not exist for &quot; + path);</span>
<span class="nc" id="L435">            return true;</span>
        }
<span class="nc" id="L437">        byte[] data = null;</span>
        try {
<span class="nc" id="L439">            data = zk.getData(quotaPath, false, new Stat());</span>
<span class="nc" id="L440">        } catch(KeeperException.NoNodeException ne) {</span>
<span class="nc" id="L441">            System.err.println(&quot;quota does not exist for &quot; + path);</span>
<span class="nc" id="L442">            return true;</span>
<span class="nc" id="L443">        }</span>
<span class="nc" id="L444">        StatsTrack strack = new StatsTrack(new String(data));</span>
<span class="nc bnc" id="L445" title="All 4 branches missed.">        if (bytes &amp;&amp; !numNodes) {</span>
<span class="nc" id="L446">            strack.setBytes(-1L);</span>
<span class="nc" id="L447">            zk.setData(quotaPath, strack.toString().getBytes(), -1);</span>
<span class="nc bnc" id="L448" title="All 4 branches missed.">        } else if (!bytes &amp;&amp; numNodes) {</span>
<span class="nc" id="L449">            strack.setCount(-1);</span>
<span class="nc" id="L450">            zk.setData(quotaPath, strack.toString().getBytes(), -1);</span>
<span class="nc bnc" id="L451" title="All 4 branches missed.">        } else if (bytes &amp;&amp; numNodes) {</span>
            // delete till you can find a node with more than
            // one child
<span class="nc" id="L454">            List&lt;String&gt; children = zk.getChildren(parentPath, false);</span>
            /// delete the direct children first
<span class="nc bnc" id="L456" title="All 2 branches missed.">            for (String child: children) {</span>
<span class="nc" id="L457">                zk.delete(parentPath + &quot;/&quot; + child, -1);</span>
<span class="nc" id="L458">            }</span>
            // cut the tree till their is more than one child
<span class="nc" id="L460">            trimProcQuotas(zk, parentPath);</span>
        }
<span class="nc" id="L462">        return true;</span>
    }

    private static void checkIfParentQuota(ZooKeeper zk, String path)
        throws InterruptedException, KeeperException
    {
<span class="fc" id="L468">        final String[] splits = path.split(&quot;/&quot;);</span>
<span class="fc" id="L469">        String quotaPath = Quotas.quotaZookeeper;</span>
<span class="pc bpc" id="L470" title="1 of 2 branches missed.">        for (String str: splits) {</span>
<span class="fc bfc" id="L471" title="All 2 branches covered.">            if (str.length() == 0) {</span>
                // this should only be for the beginning of the path
                // i.e. &quot;/...&quot; - split(path)[0] is empty string before first '/'
<span class="fc" id="L474">                continue;</span>
            }
<span class="fc" id="L476">            quotaPath += &quot;/&quot; + str;</span>
<span class="fc" id="L477">            List&lt;String&gt; children =  null;</span>
            try {
<span class="nc" id="L479">                children = zk.getChildren(quotaPath, false);</span>
<span class="fc" id="L480">            } catch(KeeperException.NoNodeException ne) {</span>
<span class="fc" id="L481">                LOG.debug(&quot;child removed during quota check&quot;, ne);</span>
<span class="fc" id="L482">                return;</span>
<span class="nc" id="L483">            }</span>
<span class="nc bnc" id="L484" title="All 2 branches missed.">            if (children.size() == 0) {</span>
<span class="nc" id="L485">                return;</span>
            }
<span class="nc bnc" id="L487" title="All 2 branches missed.">            for (String child: children) {</span>
<span class="nc bnc" id="L488" title="All 2 branches missed.">                if (Quotas.limitNode.equals(child)) {</span>
<span class="nc" id="L489">                    throw new IllegalArgumentException(path + &quot; has a parent &quot;</span>
                            + quotaPath + &quot; which has a quota&quot;);
                }
<span class="nc" id="L492">            }</span>
        }
<span class="nc" id="L494">    }</span>

    /**
     * this method creates a quota node for the path
     * @param zk the ZooKeeper client
     * @param path the path for which quota needs to be created
     * @param bytes the limit of bytes on this path
     * @param numNodes the limit of number of nodes on this path
     * @return true if its successful and false if not.
     */
    public static boolean createQuota(ZooKeeper zk, String path,
            long bytes, int numNodes)
        throws KeeperException, IOException, InterruptedException
    {
        // check if the path exists. We cannot create
        // quota for a path that already exists in zookeeper
        // for now.
<span class="fc" id="L511">        Stat initStat = zk.exists(path, false);</span>
<span class="pc bpc" id="L512" title="1 of 2 branches missed.">        if (initStat == null) {</span>
<span class="nc" id="L513">            throw new IllegalArgumentException(path + &quot; does not exist.&quot;);</span>
        }
        // now check if their is already existing
        // parent or child that has quota

<span class="fc" id="L518">        String quotaPath = Quotas.quotaZookeeper;</span>
        // check for more than 2 children --
        // if zookeeper_stats and zookeeper_qutoas
        // are not the children then this path
        // is an ancestor of some path that
        // already has quota
<span class="fc" id="L524">        String realPath = Quotas.quotaZookeeper + path;</span>
        try {
<span class="nc" id="L526">            List&lt;String&gt; children = zk.getChildren(realPath, false);</span>
<span class="nc bnc" id="L527" title="All 2 branches missed.">            for (String child: children) {</span>
<span class="nc bnc" id="L528" title="All 2 branches missed.">                if (!child.startsWith(&quot;zookeeper_&quot;)) {</span>
<span class="nc" id="L529">                    throw new IllegalArgumentException(path + &quot; has child &quot; +</span>
                            child + &quot; which has a quota&quot;);
                }
<span class="nc" id="L532">            }</span>
<span class="fc" id="L533">        } catch(KeeperException.NoNodeException ne) {</span>
            // this is fine
<span class="nc" id="L535">        }</span>

        //check for any parent that has been quota
<span class="fc" id="L538">        checkIfParentQuota(zk, path);</span>

        // this is valid node for quota
        // start creating all the parents
<span class="pc bpc" id="L542" title="1 of 2 branches missed.">        if (zk.exists(quotaPath, false) == null) {</span>
            try {
<span class="nc" id="L544">                zk.create(Quotas.procZookeeper, null, Ids.OPEN_ACL_UNSAFE,</span>
                        CreateMode.PERSISTENT);
<span class="nc" id="L546">                zk.create(Quotas.quotaZookeeper, null, Ids.OPEN_ACL_UNSAFE,</span>
                        CreateMode.PERSISTENT);
<span class="nc" id="L548">            } catch(KeeperException.NodeExistsException ne) {</span>
                // do nothing
<span class="nc" id="L550">            }</span>
        }

        // now create the direct children
        // and the stat and quota nodes
<span class="fc" id="L555">        String[] splits = path.split(&quot;/&quot;);</span>
<span class="fc" id="L556">        StringBuilder sb = new StringBuilder();</span>
<span class="fc" id="L557">        sb.append(quotaPath);</span>
<span class="fc bfc" id="L558" title="All 2 branches covered.">        for (int i=1; i&lt;splits.length; i++) {</span>
<span class="fc" id="L559">            sb.append(&quot;/&quot; + splits[i]);</span>
<span class="fc" id="L560">            quotaPath = sb.toString();</span>
            try {
<span class="fc" id="L562">                zk.create(quotaPath, null, Ids.OPEN_ACL_UNSAFE ,</span>
                        CreateMode.PERSISTENT);
<span class="nc" id="L564">            } catch(KeeperException.NodeExistsException ne) {</span>
                //do nothing
<span class="fc" id="L566">            }</span>
        }
<span class="fc" id="L568">        String statPath = quotaPath + &quot;/&quot; + Quotas.statNode;</span>
<span class="fc" id="L569">        quotaPath = quotaPath + &quot;/&quot; + Quotas.limitNode;</span>
<span class="fc" id="L570">        StatsTrack strack = new StatsTrack(null);</span>
<span class="fc" id="L571">        strack.setBytes(bytes);</span>
<span class="fc" id="L572">        strack.setCount(numNodes);</span>
        try {
<span class="fc" id="L574">            zk.create(quotaPath, strack.toString().getBytes(),</span>
                    Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
<span class="fc" id="L576">            StatsTrack stats = new StatsTrack(null);</span>
<span class="fc" id="L577">            stats.setBytes(0L);</span>
<span class="fc" id="L578">            stats.setCount(0);</span>
<span class="fc" id="L579">            zk.create(statPath, stats.toString().getBytes(),</span>
                    Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
<span class="nc" id="L581">        } catch(KeeperException.NodeExistsException ne) {</span>
<span class="nc" id="L582">            byte[] data = zk.getData(quotaPath, false , new Stat());</span>
<span class="nc" id="L583">            StatsTrack strackC = new StatsTrack(new String(data));</span>
<span class="nc bnc" id="L584" title="All 2 branches missed.">            if (bytes != -1L) {</span>
<span class="nc" id="L585">                strackC.setBytes(bytes);</span>
            }
<span class="nc bnc" id="L587" title="All 2 branches missed.">            if (numNodes != -1) {</span>
<span class="nc" id="L588">                strackC.setCount(numNodes);</span>
            }
<span class="nc" id="L590">            zk.setData(quotaPath, strackC.toString().getBytes(), -1);</span>
<span class="fc" id="L591">        }</span>
<span class="fc" id="L592">        return true;</span>
    }

    protected boolean processCmd(MyCommandOptions co)
        throws KeeperException, IOException, InterruptedException
    {
        try {
<span class="fc" id="L599">            return processZKCmd(co);</span>
<span class="nc" id="L600">        } catch (IllegalArgumentException e) {</span>
<span class="nc" id="L601">            System.err.println(&quot;Command failed: &quot; + e);</span>
<span class="fc" id="L602">        } catch (KeeperException.NoNodeException e) {</span>
<span class="fc" id="L603">            System.err.println(&quot;Node does not exist: &quot; + e.getPath());</span>
<span class="nc" id="L604">        } catch (KeeperException.NoChildrenForEphemeralsException e) {</span>
<span class="nc" id="L605">            System.err.println(&quot;Ephemerals cannot have children: &quot;</span>
<span class="nc" id="L606">                    + e.getPath());</span>
<span class="nc" id="L607">        } catch (KeeperException.NodeExistsException e) {</span>
<span class="nc" id="L608">            System.err.println(&quot;Node already exists: &quot; + e.getPath());</span>
<span class="nc" id="L609">        } catch (KeeperException.NotEmptyException e) {</span>
<span class="nc" id="L610">            System.err.println(&quot;Node not empty: &quot; + e.getPath());</span>
<span class="nc" id="L611">        } catch (KeeperException.NotReadOnlyException e) {</span>
<span class="nc" id="L612">            System.err.println(&quot;Not a read-only call: &quot; + e.getPath());</span>
<span class="fc" id="L613">        }catch (KeeperException.InvalidACLException  e) {</span>
<span class="fc" id="L614">            System.err.println(&quot;Acl is not valid : &quot;+e.getPath());</span>
<span class="nc" id="L615">        }catch (KeeperException.NoAuthException  e) {</span>
<span class="nc" id="L616">            System.err.println(&quot;Authentication is not valid : &quot;+e.getPath());</span>
<span class="nc" id="L617">        }catch (KeeperException.BadArgumentsException   e) {</span>
<span class="nc" id="L618">            System.err.println(&quot;Arguments are not valid : &quot;+e.getPath());</span>
<span class="nc" id="L619">        }catch (KeeperException.BadVersionException e) {</span>
<span class="nc" id="L620">            System.err.println(&quot;version No is not valid : &quot;+e.getPath());</span>
<span class="pc" id="L621">        }</span>
<span class="fc" id="L622">        return false;</span>
    }

    protected boolean processZKCmd(MyCommandOptions co)
        throws KeeperException, IOException, InterruptedException
    {
<span class="fc" id="L628">        Stat stat = new Stat();</span>
<span class="fc" id="L629">        String[] args = co.getArgArray();</span>
<span class="fc" id="L630">        String cmd = co.getCommand();</span>
<span class="pc bpc" id="L631" title="1 of 2 branches missed.">        if (args.length &lt; 1) {</span>
<span class="nc" id="L632">            usage();</span>
<span class="nc" id="L633">            return false;</span>
        }

<span class="pc bpc" id="L636" title="1 of 2 branches missed.">        if (!commandMap.containsKey(cmd)) {</span>
<span class="nc" id="L637">            usage();</span>
<span class="nc" id="L638">            return false;</span>
        }
        
<span class="fc bfc" id="L641" title="All 2 branches covered.">        boolean watch = args.length &gt; 2;</span>
<span class="fc" id="L642">        String path = null;</span>
<span class="fc" id="L643">        List&lt;ACL&gt; acl = Ids.OPEN_ACL_UNSAFE;</span>
<span class="fc" id="L644">        LOG.debug(&quot;Processing &quot; + cmd);</span>
        
<span class="pc bpc" id="L646" title="1 of 2 branches missed.">        if (cmd.equals(&quot;quit&quot;)) {</span>
<span class="nc" id="L647">            System.out.println(&quot;Quitting...&quot;);</span>
<span class="nc" id="L648">            zk.close();</span>
<span class="nc" id="L649">            System.exit(0);</span>
<span class="pc bpc" id="L650" title="1 of 4 branches missed.">        } else if (cmd.equals(&quot;redo&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L651">            Integer i = Integer.decode(args[1]);</span>
<span class="nc bnc" id="L652" title="All 2 branches missed.">            if (commandCount &lt;= i){ // don't allow redoing this redo</span>
<span class="nc" id="L653">                System.out.println(&quot;Command index out of range&quot;);</span>
<span class="nc" id="L654">                return false;</span>
            }
<span class="nc" id="L656">            cl.parseCommand(history.get(i));</span>
<span class="nc bnc" id="L657" title="All 2 branches missed.">            if (cl.getCommand().equals( &quot;redo&quot; )){</span>
<span class="nc" id="L658">                System.out.println(&quot;No redoing redos&quot;);</span>
<span class="nc" id="L659">                return false;</span>
            }
<span class="nc" id="L661">            history.put(commandCount, history.get(i));</span>
<span class="nc" id="L662">            processCmd( cl);</span>
<span class="pc bfc" id="L663" title="All 2 branches covered.">        } else if (cmd.equals(&quot;history&quot;)) {</span>
<span class="fc bfc" id="L664" title="All 2 branches covered.">            for (int i=commandCount - 10;i&lt;=commandCount;++i) {</span>
<span class="fc bfc" id="L665" title="All 2 branches covered.">                if (i &lt; 0) continue;</span>
<span class="fc" id="L666">                System.out.println(i + &quot; - &quot; + history.get(i));</span>
            }
<span class="fc bfc" id="L668" title="All 2 branches covered.">        } else if (cmd.equals(&quot;printwatches&quot;)) {</span>
<span class="pc bpc" id="L669" title="1 of 2 branches missed.">            if (args.length == 1) {</span>
<span class="pc bpc" id="L670" title="1 of 2 branches missed.">                System.out.println(&quot;printwatches is &quot; + (printWatches ? &quot;on&quot; : &quot;off&quot;));</span>
            } else {
<span class="nc" id="L672">                printWatches = args[1].equals(&quot;on&quot;);</span>
            }
<span class="pc bpc" id="L674" title="1 of 2 branches missed.">        } else if (cmd.equals(&quot;connect&quot;)) {</span>
<span class="nc bnc" id="L675" title="All 2 branches missed.">            if (args.length &gt;=2) {</span>
<span class="nc" id="L676">                connectToZK(args[1]);</span>
            } else {
<span class="nc" id="L678">                connectToZK(host);                </span>
            }
        } 
        
        // Below commands all need a live connection
<span class="pc bpc" id="L683" title="2 of 4 branches missed.">        if (zk == null || !zk.getState().isAlive()) {</span>
<span class="nc" id="L684">            System.out.println(&quot;Not connected&quot;);</span>
<span class="nc" id="L685">            return false;</span>
        }
        
<span class="pc bpc" id="L688" title="1 of 4 branches missed.">        if (cmd.equals(&quot;create&quot;) &amp;&amp; args.length &gt;= 3) {</span>
<span class="fc" id="L689">            int first = 0;</span>
<span class="fc" id="L690">            CreateMode flags = CreateMode.PERSISTENT;</span>
<span class="pc bpc" id="L691" title="3 of 4 branches missed.">            if ((args[1].equals(&quot;-e&quot;) &amp;&amp; args[2].equals(&quot;-s&quot;))</span>
<span class="pc bpc" id="L692" title="2 of 4 branches missed.">                    || (args[1]).equals(&quot;-s&quot;) &amp;&amp; (args[2].equals(&quot;-e&quot;))) {</span>
<span class="fc" id="L693">                first+=2;</span>
<span class="fc" id="L694">                flags = CreateMode.EPHEMERAL_SEQUENTIAL;</span>
<span class="nc bnc" id="L695" title="All 2 branches missed.">            } else if (args[1].equals(&quot;-e&quot;)) {</span>
<span class="nc" id="L696">                first++;</span>
<span class="nc" id="L697">                flags = CreateMode.EPHEMERAL;</span>
<span class="nc bnc" id="L698" title="All 2 branches missed.">            } else if (args[1].equals(&quot;-s&quot;)) {</span>
<span class="nc" id="L699">                first++;</span>
<span class="nc" id="L700">                flags = CreateMode.PERSISTENT_SEQUENTIAL;</span>
            }
<span class="fc bfc" id="L702" title="All 2 branches covered.">            if (args.length == first + 4) {</span>
<span class="fc" id="L703">                acl = parseACLs(args[first+3]);</span>
            }
<span class="fc" id="L705">            path = args[first + 1];</span>
<span class="fc" id="L706">            String newPath = zk.create(path, args[first+2].getBytes(), acl,</span>
                    flags);
<span class="fc" id="L708">            System.err.println(&quot;Created &quot; + newPath);</span>
<span class="pc bpc" id="L709" title="1 of 4 branches missed.">        } else if (cmd.equals(&quot;delete&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="fc" id="L710">            path = args[1];</span>
<span class="pc bpc" id="L711" title="1 of 2 branches missed.">            zk.delete(path, watch ? Integer.parseInt(args[2]) : -1);</span>
<span class="pc bpc" id="L712" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;rmr&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L713">            path = args[1];</span>
<span class="nc" id="L714">            ZKUtil.deleteRecursive(zk, path);</span>
<span class="pc bpc" id="L715" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;set&quot;) &amp;&amp; args.length &gt;= 3) {</span>
<span class="nc" id="L716">            path = args[1];</span>
<span class="nc bnc" id="L717" title="All 2 branches missed.">            stat = zk.setData(path, args[2].getBytes(),</span>
<span class="nc" id="L718">                    args.length &gt; 3 ? Integer.parseInt(args[3]) : -1);</span>
<span class="nc" id="L719">            printStat(stat);</span>
<span class="pc bpc" id="L720" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;aget&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L721">            path = args[1];</span>
<span class="nc" id="L722">            zk.getData(path, watch, dataCallback, path);</span>
<span class="pc bpc" id="L723" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;get&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L724">            path = args[1];</span>
<span class="nc" id="L725">            byte data[] = zk.getData(path, watch, stat);</span>
<span class="nc bnc" id="L726" title="All 2 branches missed.">            data = (data == null)? &quot;null&quot;.getBytes() : data;</span>
<span class="nc" id="L727">            System.out.println(new String(data));</span>
<span class="nc" id="L728">            printStat(stat);</span>
<span class="pc bpc" id="L729" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;ls&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L730">            path = args[1];</span>
<span class="nc" id="L731">            List&lt;String&gt; children = zk.getChildren(path, watch);</span>
<span class="nc" id="L732">            System.out.println(children);</span>
<span class="pc bpc" id="L733" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;ls2&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L734">            path = args[1];</span>
<span class="nc" id="L735">            List&lt;String&gt; children = zk.getChildren(path, watch, stat);</span>
<span class="nc" id="L736">            System.out.println(children);</span>
<span class="nc" id="L737">            printStat(stat);</span>
<span class="pc bpc" id="L738" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;getAcl&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L739">            path = args[1];</span>
<span class="nc" id="L740">            acl = zk.getACL(path, stat);</span>
<span class="nc bnc" id="L741" title="All 2 branches missed.">            for (ACL a : acl) {</span>
<span class="nc" id="L742">                System.out.println(a.getId() + &quot;: &quot;</span>
<span class="nc" id="L743">                        + getPermString(a.getPerms()));</span>
<span class="nc" id="L744">            }</span>
<span class="pc bpc" id="L745" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;setAcl&quot;) &amp;&amp; args.length &gt;= 3) {</span>
<span class="nc" id="L746">            path = args[1];</span>
<span class="nc bnc" id="L747" title="All 2 branches missed.">            stat = zk.setACL(path, parseACLs(args[2]),</span>
<span class="nc" id="L748">                    args.length &gt; 4 ? Integer.parseInt(args[3]) : -1);</span>
<span class="nc" id="L749">            printStat(stat);</span>
<span class="pc bpc" id="L750" title="1 of 4 branches missed.">        } else if (cmd.equals(&quot;stat&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="fc" id="L751">            path = args[1];</span>
<span class="fc" id="L752">            stat = zk.exists(path, watch);</span>
<span class="pc bpc" id="L753" title="1 of 2 branches missed.">            if (stat == null) {</span>
<span class="fc" id="L754">              throw new KeeperException.NoNodeException(path);	</span>
            }
<span class="nc" id="L756">            printStat(stat);</span>
<span class="pc bpc" id="L757" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;listquota&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L758">            path = args[1];</span>
<span class="nc" id="L759">            String absolutePath = Quotas.quotaZookeeper + path + &quot;/&quot; + Quotas.limitNode;</span>
<span class="nc" id="L760">            byte[] data =  null;</span>
            try {
<span class="nc" id="L762">                System.err.println(&quot;absolute path is &quot; + absolutePath);</span>
<span class="nc" id="L763">                data = zk.getData(absolutePath, false, stat);</span>
<span class="nc" id="L764">                StatsTrack st = new StatsTrack(new String(data));</span>
<span class="nc" id="L765">                System.out.println(&quot;Output quota for &quot; + path + &quot; &quot;</span>
<span class="nc" id="L766">                        + st.toString());</span>

<span class="nc" id="L768">                data = zk.getData(Quotas.quotaZookeeper + path + &quot;/&quot; +</span>
                        Quotas.statNode, false, stat);
<span class="nc" id="L770">                System.out.println(&quot;Output stat for &quot; + path + &quot; &quot; +</span>
<span class="nc" id="L771">                        new StatsTrack(new String(data)).toString());</span>
<span class="nc" id="L772">            } catch(KeeperException.NoNodeException ne) {</span>
<span class="nc" id="L773">                System.err.println(&quot;quota for &quot; + path + &quot; does not exist.&quot;);</span>
<span class="nc" id="L774">            }</span>
<span class="pc bpc" id="L775" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;setquota&quot;) &amp;&amp; args.length &gt;= 4) {</span>
<span class="nc" id="L776">            String option = args[1];</span>
<span class="nc" id="L777">            String val = args[2];</span>
<span class="nc" id="L778">            path = args[3];</span>
<span class="nc" id="L779">            System.err.println(&quot;Comment: the parts are &quot; +</span>
                               &quot;option &quot; + option +
                               &quot; val &quot; + val +
                               &quot; path &quot; + path);
<span class="nc bnc" id="L783" title="All 2 branches missed.">            if (&quot;-b&quot;.equals(option)) {</span>
                // we are setting the bytes quota
<span class="nc" id="L785">                createQuota(zk, path, Long.parseLong(val), -1);</span>
<span class="nc bnc" id="L786" title="All 2 branches missed.">            } else if (&quot;-n&quot;.equals(option)) {</span>
                // we are setting the num quota
<span class="nc" id="L788">                createQuota(zk, path, -1L, Integer.parseInt(val));</span>
            } else {
<span class="nc" id="L790">                usage();</span>
            }

<span class="pc bpc" id="L793" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;delquota&quot;) &amp;&amp; args.length &gt;= 2) {</span>
            //if neither option -n or -b is specified, we delete
            // the quota node for thsi node.
<span class="nc bnc" id="L796" title="All 2 branches missed.">            if (args.length == 3) {</span>
                //this time we have an option
<span class="nc" id="L798">                String option = args[1];</span>
<span class="nc" id="L799">                path = args[2];</span>
<span class="nc bnc" id="L800" title="All 2 branches missed.">                if (&quot;-b&quot;.equals(option)) {</span>
<span class="nc" id="L801">                    delQuota(zk, path, true, false);</span>
<span class="nc bnc" id="L802" title="All 2 branches missed.">                } else if (&quot;-n&quot;.equals(option)) {</span>
<span class="nc" id="L803">                    delQuota(zk, path, false, true);</span>
                }
<span class="nc bnc" id="L805" title="All 2 branches missed.">            } else if (args.length == 2) {</span>
<span class="nc" id="L806">                path = args[1];</span>
                // we dont have an option specified.
                // just delete whole quota node
<span class="nc" id="L809">                delQuota(zk, path, true, true);</span>
<span class="nc bnc" id="L810" title="All 2 branches missed.">            } else if (cmd.equals(&quot;help&quot;)) {</span>
<span class="nc" id="L811">                usage();</span>
            }
<span class="pc bpc" id="L813" title="1 of 2 branches missed.">        } else if (cmd.equals(&quot;close&quot;)) {</span>
<span class="nc" id="L814">                zk.close();            </span>
<span class="pc bpc" id="L815" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;sync&quot;) &amp;&amp; args.length &gt;= 2) {</span>
<span class="nc" id="L816">            path = args[1];</span>
<span class="nc" id="L817">            zk.sync(path, new AsyncCallback.VoidCallback() { public void processResult(int rc, String path, Object ctx) { System.out.println(&quot;Sync returned &quot; + rc); } }, null );</span>
<span class="pc bpc" id="L818" title="3 of 4 branches missed.">        } else if (cmd.equals(&quot;addauth&quot;) &amp;&amp; args.length &gt;=2 ) {</span>
<span class="nc" id="L819">            byte[] b = null;</span>
<span class="nc bnc" id="L820" title="All 2 branches missed.">            if (args.length &gt;= 3)</span>
<span class="nc" id="L821">                b = args[2].getBytes();</span>

<span class="nc" id="L823">            zk.addAuthInfo(args[1], b);</span>
<span class="pc bpc" id="L824" title="1 of 2 branches missed.">        } else if (!commandMap.containsKey(cmd)) {</span>
<span class="nc" id="L825">            usage();</span>
        }
<span class="fc" id="L827">        return watch;</span>
    }

    private static String getPermString(int perms) {
<span class="nc" id="L831">        StringBuilder p = new StringBuilder();</span>
<span class="nc bnc" id="L832" title="All 2 branches missed.">        if ((perms &amp; ZooDefs.Perms.CREATE) != 0) {</span>
<span class="nc" id="L833">            p.append('c');</span>
        }
<span class="nc bnc" id="L835" title="All 2 branches missed.">        if ((perms &amp; ZooDefs.Perms.DELETE) != 0) {</span>
<span class="nc" id="L836">            p.append('d');</span>
        }
<span class="nc bnc" id="L838" title="All 2 branches missed.">        if ((perms &amp; ZooDefs.Perms.READ) != 0) {</span>
<span class="nc" id="L839">            p.append('r');</span>
        }
<span class="nc bnc" id="L841" title="All 2 branches missed.">        if ((perms &amp; ZooDefs.Perms.WRITE) != 0) {</span>
<span class="nc" id="L842">            p.append('w');</span>
        }
<span class="nc bnc" id="L844" title="All 2 branches missed.">        if ((perms &amp; ZooDefs.Perms.ADMIN) != 0) {</span>
<span class="nc" id="L845">            p.append('a');</span>
        }
<span class="nc" id="L847">        return p.toString();</span>
    }

    private static List&lt;ACL&gt; parseACLs(String aclString) {
        List&lt;ACL&gt; acl;
<span class="fc" id="L852">        String acls[] = aclString.split(&quot;,&quot;);</span>
<span class="fc" id="L853">        acl = new ArrayList&lt;ACL&gt;();</span>
<span class="fc bfc" id="L854" title="All 2 branches covered.">        for (String a : acls) {</span>
<span class="fc" id="L855">            int firstColon = a.indexOf(':');</span>
<span class="fc" id="L856">            int lastColon = a.lastIndexOf(':');</span>
<span class="pc bpc" id="L857" title="3 of 6 branches missed.">            if (firstColon == -1 || lastColon == -1 || firstColon == lastColon) {</span>
<span class="nc" id="L858">                System.err</span>
<span class="nc" id="L859">                .println(a + &quot; does not have the form scheme:id:perm&quot;);</span>
<span class="nc" id="L860">                continue;</span>
            }
<span class="fc" id="L862">            ACL newAcl = new ACL();</span>
<span class="fc" id="L863">            newAcl.setId(new Id(a.substring(0, firstColon), a.substring(</span>
                    firstColon + 1, lastColon)));
<span class="fc" id="L865">            newAcl.setPerms(getPermFromString(a.substring(lastColon + 1)));</span>
<span class="fc" id="L866">            acl.add(newAcl);</span>
        }
<span class="fc" id="L868">        return acl;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>